<template>
  <div id="institution_index_wrapper" class="bt-container">   
    <!--뒤로가기 추가-->
     <div style="display:inline; float: right; margin-top:50px">
      <a href="javascript:history.back();">
        <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
      </a>
    </div>  
    <h2 class="page-title">{{ $t('HEADER.OPEN_SPACE') }}</h2>   
    <div
      v-if="!loading">
      <i class="el-icon-loading" style="font-size: 50px; float: left"></i>
    </div>
    <student-class-table
      v-show="loading"
      type="OPEN"
      :list="list"
      :rowClick="rowClick"
      :onClick="onClick"
    />
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import StudentClassTable from '../partials/StudentClassTable';
import utils from '../../utils';
import openspaceService from '../../services/openspaceService';

export default {
  name: 'ClassIndex',
  components: {
    StudentClassTable,
  },
  data() {
    return {
      loading: false,
      userId: utils.getUserIdFromJwt(),
      searchType: 'name',
      searchText: '',
      list: [],
    };
  },
  computed: {
    ...mapState('NNclass', ['openPreviewClassList']),
  },
  async beforeMount() {
    const vm = this;

    // 새로고침(Refresh, F5) 해도 목록을 가져올 수 있게 하는 부분.
    // TODO: 속도가 눈에 보이게 느려지므로 다른 방법이 있다면 수정 요구.
    await vm.getOpenPreviewClass({
      affiliationId: vm.$route.params.affiliationId
    });
    // 검색 기능 : 서버에서 DB 쿼리로 처리하는 게 효율이 나을 것 같으면 나중에 수정.
    if (vm.openPreviewClassList !== null) {
      if (vm.$route.query.text !== undefined) {
        vm.searchText = vm.$route.query.text;
      }
      for (let i = 0; i < vm.openPreviewClassList.length; i += 1) {
        if (vm.searchType === 'name') {
          if (vm.openPreviewClassList[i].name.includes(vm.searchText)) {
            vm.list.push(vm.openPreviewClassList[i]);
          }
        }
      }
    }
    vm.loading = true;
  },
  methods: {
    ...mapActions('NNclass', [
      'getOpenPreviewClass',
    ]),
    formatDate: utils.formatDate,
    async onClick(type, arg, arg2) {
      const vm = this;
      switch (type) {
        case 'DETAIL': {
          vm.$router.push(`/class/${arg.class_id}/classdetail`);
          break;
        }
        case 'LISTEN': {
          // rowClick 기능이랑 겹침
          vm.$router.push(`/a/student/NNclass/${arg.class_id}`);
          break;
        }
        case 'CANCEL': {
          vm.$confirm(vm.$t('CONFIRM.WANT_CNL_CRS'), `${arg.name || ''} ` + vm.$t('CONFIRM.CANCEL_COURSE'), {
            confirmButtonText: vm.$t('CONFIRM.YES_CANCEL'),
            cancelButtonText: vm.$t('CONFIRM.NO_CANCEL'),
            type: 'warning',
          })
          .then(async () => {
            try {
              await vm.deleteClassUser({
                classId: arg.class_id,
                userId: vm.userId,
              });

              vm.$notify({
                title: vm.$t('NOTIFY.CUR_CNCL_SUC'),
                message: vm.$t('NOTIFY.CUR_CNCLED'),
                type: 'success',
                duration: 3000,
              });
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.CUR_CNCL_FAIL'),
                message: error.toString(),
                type: 'error',
                duration: 3000,
              });
            }

            try {
              await vm.getMyClassLists();
              vm.list.splice(arg2, 1);
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.FAIL_IMP_SUBJ_LIST'),
                message: error.toString(),
                type: 'error',
                duration: 0,
              });
            }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t('NOTIFY.INTERRUPTED'),
              message: vm.$t('NOTIFY.CUR_SGN_UP_INTRP'),
              type: 'info',
              duration: 3000,
            });
          });
          break;
        }
        case 'SEARCH': {
          vm.$router.push({ path: '/a/student/NNclass', query: { type: `${arg.searchType}`, text: `${arg.searchText}` } });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    // 테이블 클릭하면 해당 과목으로 이동하도록 190821
    async rowClick(row, _, column) {
      const vm = this;
      if (column.label === '-') {
        return;
      }
      const res = await openspaceService.postOpenInstitutionUserClass({
        classId: row.class_id
      });
      vm.$router.push(`/a/student/NNclass/${row.class_id}`);
    },
  },
};
</script>


<style lang="scss" scoped>

#class_index_wrapper {
  .page-title{
    height: 24px;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 25px;
  }
}
</style>
